#include "ToSort.h"
#include "SorterFactory.h"
#include <string>
#include <iostream>
#include <vector>
#include "File.h"
#include "FileWithHeap.h"

void sortByTwoMethods(std::wstring path)
{
	using namespace std;

	File nfile(path);

	int dot_pos = path.find_last_of(L'.');
	
    File &QFile = nfile.copy(wstring(path).insert(dot_pos, L"Quick"));

	Sorter &QuickSorter = SorterFactory::getInstance(QuickSort);
	int size = QFile.getFileSize();

	QuickSorter.sort(QFile.MapToRAM(), size);

//	Sorter &QuickSorter = SorterFactory::getInstance(QuickSort);
	FileWithHeap nefile(path);

//	FileWithHeap &HQFile = nefile.copy(wstring(path).insert(dot_pos, L"QuickHeap"));
//	QuickSorter.sort(HQFile.getPtr(), HQFile.getFileSize());
//	HQFile.flush();

	return;
}