#include "QuickSort.h"
#include <iostream>

void QuickSorter::sort(void *toSort, int size)
{
	qsort(toSort, 0, size - 1 );
}

void QuickSorter::qsort(void *toSort, int li, int ri)
{
	char *SArray = reinterpret_cast<char *>(toSort);
	if (li < ri)
	{
		int q = partition(SArray, li, ri);
		qsort(SArray, li, q - 1);
		qsort(SArray, q + 1, ri);
	}
	return;
}

int QuickSorter::partition(char *toSort, int l, int r)
{
	int i = l - 1;
	char x = toSort[r];
	int j;

	for (j = l; j < r; j++)
	{
		if (x <= toSort[j])
		{
			++i;
			char temp = toSort[i];
			toSort[i] = toSort[j];
			toSort[j] = temp;
		}
	}

	char temp = toSort[i + 1];
	toSort[i + 1] = toSort[r];
	toSort[r] = temp;

	return i + 1;
}